NB. 2D graphics definitions

coclass 'jgl2'

PS_DASH=: 1
PS_DASHDOT=: 3
PS_DASHDOTDOT=: 4
PS_DOT=: 2
PS_INSIDEFRAME=: 6
PS_NULL=: 5
PS_SOLID=: 0

NB. There are 4 standard mapping modes:
NB. MM_DEFAULT - x right, y up, scales glwindowext (1000 1000) to fit
NB. MM_RAW = MM_TEXT - x right, y down, units are pixels
NB. MM_RIGHTDOWN - x right, y down, scales glwindowext to fit
NB. MM_TWIPS - values are twips (win32 only)

MM_DEFAULT=: 0
MM_TEXT=: 1
MM_RAW=: 1
MM_RIGHTDOWN=: 2
MM_TWIPS=: 6

TA_NOUPDATECP=: 0
TA_UPDATECP=: 1
TA_LEFT=: 0
TA_RIGHT=: 2
TA_CENTER=: 6
TA_TOP=: 0
TA_BOTTOM=: 8
TA_BASELINE=: 24

IDC_ARROW=: 32512
IDC_IBEAM=: 32513
IDC_WAIT=: 32514
IDC_CROSS=: 32515
IDC_UPARROW=: 32516
IDC_SIZENWSE=: 32642
IDC_SIZENESW=: 32643
IDC_SIZEWE=: 32644
IDC_SIZENS=: 32645
IDC_SIZEALL=: 32646
IDC_NO=: 32648
IDC_APPSTARTING=: 32650
IDC_HELP=: 32651

glarc=: 11!:2001
glbkcolor=: 11!:2002
glbkmode=: 11!:2003
glbrush=: 11!:2004
glbrushnull=: 11!:2005
glchord=: 11!:2006
glclear=: 11!:2007
glellipse=: 11!:2008
glextent=: 11!:2009
glextentfont=: 11!:2010
glflood=: 11!:2011
glfont=: 11!:2012
glline=: 11!:2013
gllined=: 11!:2014
gllines=: 11!:2015
glmap=: 11!:2016
glmark=: 11!:2017
glmarkc=: 11!:2018
glmove=: 11!:2019
glpaint=: 11!:2020
glpaintx=: 11!:2021
glpen=: 11!:2022
glpie=: 11!:2023
glpixel=: 11!:2024
glplay=: 11!:2025
glplayext=: 11!:2026
glplaymap=: 11!:2027
glplayxywh=: 11!:2028
glpolygon=: 11!:2029
glpolymode=: 11!:2030
glrect=: 11!:2031
glrgb=: 11!:2032
glroundr=: 11!:2033
glsave=: 11!:2034
glsel=: 11!:2035
glshow=: 11!:2036
glshowx=: 11!:2037
gltext=: 11!:2038
gltextalign=: 11!:2039
gltextcolor=: 11!:2040
gltextjustify=: 11!:2041
gltop=: 11!:2043
glwindowext=: 11!:2044
glwindoworg=: 11!:2045
glzabortdoc=: 11!:2046
glzcreate=: 11!:2047
glzdelete=: 11!:2048
glzdevmode=: 11!:2049
glzenddoc=: 11!:2050
glzendpage=: 11!:2051
glzmap=: 11!:2052
glzprint=: 11!:2053
glzstartdoc=: 11!:2054
glzstartpage=: 11!:2055
gltextxy=: 11!:2056
glqextent=: 11!:2057
glqtextmetrics=: 11!:2058
glqwh=: 11!:2059
glqdevmode=: 11!:2060
glqprinter=: 11!:2061
glcapture=: 11!:2062
glbmp=: 11!:2063
glbmpxywh=: 11!:2064
glcaret=: 11!:2065
glfile=: 11!:2066
glsavebmp=: 11!:2067
glwantresize=: 11!:2068
glcursor=: 11!:2069
glnodblbuf=: 11!:2070
glnoerasebkgnd=: 11!:2071
glgrid=: 11!:2072
glzprintpage=: 11!:2073
glzstartprint=: 11!:2074
glzorientation=: 11!:2075
glpixels=: 11!:2076
glqpixels=: 11!:2077
glclip=: 11!:2078
glclipreset=: 11!:2079

glgridw=: 11!:2200
glgridh=: 11!:2201
glgridtext=: 11!:2202
glgridmark=: 11!:2203
glgridatt=: 11!:2204
glgridedit=: 11!:2205
glgridgetedit=: 11!:2206
glgridinvalidate=: 11!:2207
glgridtype=: 11!:2208
glgridfix=: 11!:2209
glgridscroll=: 11!:2210
glgridskip=: 11!:2211
glgriddrawmark=: 11!:2212
glgridborder=: 11!:2213
glgridfill=: 11!:2214
glgridfont0=: 11!:2215
glgridfont1=: 11!:2216

glgridrc=: 11!:2218
glgridrchw=: 11!:2219
glgridgettype=: 11!:2220
glgridgettext=: 11!:2221
glgridspace=: 11!:2222
