NB. example scripts for user definitions

NB.*brep v boxed representation
NB.*tree v tree representation
NB.*lrep v linear representation
NB.*prep v parenthesized representation
NB.*snap v names snapshot
NB.*time v time
NB.*pps v set print precision

cocurrent 'z'

brep=: 5!:2@boxopen
tree=: 5!:4@boxopen
lrep=: 5!:5@boxopen
prep=: 5!:6@boxopen
snap=: 4!:5
time=: 6!:0
pps=: 9!:11

NB. =========================================================
NB.*timex v time expressions
NB. Form: [repetitions] timex 'expression'
timex=: 6!:2

NB.*timespacex v time and space for expressions
NB. Form: [repetitions] timex 'expression'
NB. Example:
NB.    10 timespacex &> 'q:123456787';'3^10000x'
NB. 0.005 58432
NB. 0.061 52352
timespacex=: 6!:2 , 7!:2@]

NB. =========================================================
NB.*tolist v convert boxed list to LF delimited list
tolist=: }. @ ; @: (LF&, @ , @ ": each)
